/* 
 *  Simple LEDS control usign LABVIEW and ARDUINO UNO
 * VLAD MIHAI PLACINTA */

//pin numbers to which LEDs are attached
int led0= 13;
int led1= 11;
int led2= 9;
int led3= 8;
int led4= 7;
int led5= 5;
int led6= 3;
int led7= 2;

int AByte = 0;         // UART buffer

void setup() { 
    Serial.begin(115200);  // UART initialization: 115200 baud
                 
  // initialize the digital pins as outputs.
  pinMode(led0, OUTPUT);
  pinMode(led1, OUTPUT);
  pinMode(led2, OUTPUT);
  pinMode(led3, OUTPUT);
  pinMode(led4, OUTPUT);
  pinMode(led5, OUTPUT);
  pinMode(led6, OUTPUT);
  pinMode(led7, OUTPUT);
   
 // initialize default state of the LEDS , LOW.
  digitalWrite(led0, LOW);
  analogWrite(led1, 0);
  analogWrite(led2, 0);
  digitalWrite(led3, LOW);
  digitalWrite(led4, LOW);
  analogWrite(led5, 0);
  analogWrite(led6, 0);
  digitalWrite(led7, LOW);
 
        
}

// the loop routine runs over and over again forever:
void loop() {
   AByte = Serial.read(); 
   
   
   // control state for LEDS
   if (AByte == 'Q' )  {
   digitalWrite(led0, HIGH);  
   }
   if (AByte == 'A' )  {
   digitalWrite(led0, LOW);  
   }
   if (AByte == 'W' )  {
   analogWrite(led1, 255);  
   }
   if (AByte == 'S' )  {
   analogWrite(led1, 0);  
   }
   if (AByte == 'E' )  {
    analogWrite(led2, 255);   
   }
   if (AByte == 'D' )  {
   analogWrite(led2, 0);  
   }
   if (AByte == 'R' )  {
    digitalWrite(led3, HIGH);  
   }
   if (AByte == 'F' )  {
   digitalWrite(led3, LOW);  
   }
   if (AByte == 'T' )  {
   digitalWrite(led4, HIGH);  
   }
   if (AByte == 'G' )  {
   digitalWrite(led4, LOW);  
   }
   if (AByte == 'Y' )  {
    analogWrite(led5, 255);  
   }
   if (AByte == 'H' )  {
    analogWrite(led5, 0);   
   }
   if (AByte == 'U' )  {
    analogWrite(led6, 255);   
   }
   if (AByte == 'J' )  {
    analogWrite(led6, 0);   
   }
   if (AByte == 'I' )  {
   digitalWrite(led7, HIGH);  
   }
   if (AByte == 'K' )  {
   digitalWrite(led7, LOW);  
   }
   
   if (AByte == 'X' )  {
     forward();
   }
   if (AByte == 'V' )  {
     backward();
   }

   
   if (AByte == 'a' )  {    
  analogWrite(led1, 0);  // write pwm value to led1
  analogWrite(led2, 0);  // write pwm value to led2
  analogWrite(led5, 0);  // write pwm value to led5
  analogWrite(led6, 0);  // write pwm value to led6
   }
      if (AByte == 'b' )  {    
  analogWrite(led1, 50);  // write pwm value to led1
  analogWrite(led2, 50);  // write pwm value to led2
  analogWrite(led5, 50);  // write pwm value to led5
  analogWrite(led6, 50);  // write pwm value to led6
   }
      if (AByte == 'c' )  {    
  analogWrite(led1, 100);  // write pwm value to led1
  analogWrite(led2, 100);  // write pwm value to led2
  analogWrite(led5, 100);  // write pwm value to led5
  analogWrite(led6, 100);  // write pwm value to led6
   }
      if (AByte == 'd' )  {    
  analogWrite(led1, 150);  // write pwm value to led1
  analogWrite(led2, 150);  // write pwm value to led2
  analogWrite(led5, 150);  // write pwm value to led5
  analogWrite(led6, 150);  // write pwm value to led6
   }
      if (AByte == 'e' )  {    
  analogWrite(led1, 200);  // write pwm value to led1
  analogWrite(led2, 200);  // write pwm value to led2
  analogWrite(led5, 200);  // write pwm value to led5
  analogWrite(led6, 200);  // write pwm value to led6
   }
     if (AByte == 'f' )  {    
  analogWrite(led1, 255);  // write pwm value to led1
  analogWrite(led2, 255);  // write pwm value to led2
  analogWrite(led5, 255);  // write pwm value to led5
  analogWrite(led6, 255);  // write pwm value to led6
   }
 
 delay(100); //delay 100ms              
}

void forward() {
  all_off();  
  for (int i=0; i < 5 ; i++) {
  digitalWrite(led0, HIGH); 
  delay(100); //delay 100ms  
  digitalWrite(led0, LOW);
   
  analogWrite(led1, 255); 
  delay(100); //delay 100ms  
  analogWrite(led1, 0);
   
  analogWrite(led2, 255); 
  delay(100); //delay 100ms  
  analogWrite(led2, 0);
   
  digitalWrite(led3, HIGH); 
  delay(100); //delay 100ms  
  digitalWrite(led3, LOW); 
  
  digitalWrite(led4, HIGH); 
  delay(100); //delay 100ms  
  digitalWrite(led4, LOW); 
  
  analogWrite(led5, 255); 
  delay(100); //delay 100ms  
  analogWrite(led5, 0);
   
  analogWrite(led6, 255); 
  delay(100); //delay 100ms  
  analogWrite(led6, 0);
   
  digitalWrite(led7, HIGH); 
  delay(100); //delay 100ms  
  digitalWrite(led7, LOW); 
    
  }
}
 
void backward() {
  all_off();
  
  for (int i=0; i < 5 ; i++) {
  digitalWrite(led7, HIGH); 
  delay(100); //delay 100ms  
  digitalWrite(led7, LOW);
   
 analogWrite(led6, 255); 
  delay(100); //delay 100ms  
  analogWrite(led6, 0);
   
  analogWrite(led5, 255); 
  delay(100); //delay 100ms  
  analogWrite(led5, 0);
   
  digitalWrite(led4, HIGH); 
  delay(100); //delay 100ms  
  digitalWrite(led4, LOW); 
  
  digitalWrite(led3, HIGH); 
  delay(100); //delay 100ms  
  digitalWrite(led3, LOW); 
  
  analogWrite(led2, 255); 
  delay(100); //delay 100ms  
  analogWrite(led2, 0);
   
  analogWrite(led1, 255); 
  delay(100); //delay 100ms  
  analogWrite(led1, 0);
  digitalWrite(led0, HIGH); 
  delay(100); //delay 100ms  
  digitalWrite(led0, LOW); 
  
  }
}
  void all_off() {
    
    digitalWrite(led0, LOW);
    digitalWrite(led1, LOW);
    digitalWrite(led2, LOW);
    digitalWrite(led3, LOW);
    digitalWrite(led4, LOW);
    digitalWrite(led5, LOW);
    digitalWrite(led6, LOW);
    digitalWrite(led7, LOW);       
    }
