
#define trigPin 13
#define echoPin 12
int AByte = 0;         // UART buffer

void setup() {
  Serial.begin (115200);
  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);
  
}

void loop() {
  AByte = Serial.read(); 
  long duration, distance;
  digitalWrite(trigPin, LOW);  
  delayMicroseconds(2);         
  digitalWrite(trigPin, HIGH);

  delayMicroseconds(10); 
  digitalWrite(trigPin, LOW);
  duration = pulseIn(echoPin, HIGH);
  distance = (duration/2) / 29.1;
  
  if (AByte == 'A' )  { // if A char is received from UART/LabVIEW, then send the data 
     Serial.print('Z');
    Serial.print(distance);
    Serial.print('\n');
  }
  
  delay(100);
}
